% Funcin para colocar el brazo en la poscin inicial o "hard home"
% Cuando los microswitches estn pulsados recibimos un 0
% Cuando no lo est, recibimos un 1

function posInicial()
    global a; % Cargar variable global a
    % Crear las variables globales pos4 y pos5 para la mueca
    global pos4;
    global pos5;

    pinMS = [14,15,16,17,18]; % Pines de los microwitches
    digitalWrite(a,52,1); % Se enciende el tercer led rojo
    
    % Se imprime un mensaje por pantalla
    fprintf('Realizando el posicionamiento inicial'); 
    
    %%
    %Posicionar Base
    dir=0; % Mover primero en la direccin 0
    
    % Mientras no se pulse el microswitch:
    while digitalRead(a,pinMS(1))==1 
        enc = encoder(1); % Se lee el contador del encoder
        motor(1,dir,1); % Se mueve el motor en la direccin inicial
        pause(0.01); % Pausa de 0.01 segundos
        % Si el contador no se ha incrementado hemos llegado al extremo
        % y se cambia la direccin del motor
        if enc == encoder(1)
            dir=1;
        end
    end
    % Cuando se pulsa el microswitch se para el motor.
    motor(1,0,0)
    fprintf('.');
    
    %%
    %Posicionar Antebrazo
    dir2=0; % Mover primero en la direccin 0
    
    % Mientras que la direccin del motor sea 0:
    while dir2 == 0
        
        % Mientras se mantenga pulsado el boton el motor se mover
        % en esa direccin
        while digitalRead(a,pinMS(2))==0
            motor(2,dir2,1);
        end
 
        dir2=1; % Se cambia la direccin a 1
        % Mientras el MS est sin pulsar:
        while digitalRead(a,pinMS(2))==1
            enc = encoder(2);% Almacenar el valor del contador
            motor(2,dir2,1); % Mover el motor
            pause(0.01); % Pausar 0.01 segundos
            % Si el contador no ha cambiado cambiar la direccin
            if enc == encoder(2)
                dir2=0;
            end
        end
    end
    motor(2,0,0); %Parar el motor 
    fprintf('.');
    
    %%
    %Posicionar Brazo
    dir3=0;% Mover primero en la direccin 0
   
    % Mientras que la direccin del motor sea 0:
    while dir3 == 0 
        
        % Mientras se mantenga pulsado el boton el motor se mover
        % en esa direccin
        while digitalRead(a,pinMS(3))==0
            motor(3,dir3,1);
        end

        dir3=1;  % Se cambia la direccin a 1
        
        % Mientras el MS est sin pulsar:
        while digitalRead(a,pinMS(3))==1
            enc = encoder(3); % Almacenar el valor del contador
            motor(3,dir3,1); % Mover el motor
            pause(0.01); % Pausar 0.01 segundos
            % Si el contador no ha cambiado cambiar la direccin
            if enc == encoder(3)
                dir3=0;
            end
        end
    end
    motor(3,0,0); % Parar el motor
    fprintf('.');
    %%
    %Posicionar herramienta (Plano vertical)
    dir4=1; % Mover primero en la direccin 1
    
    % Mientras que la direccin del motor sea 1:
    while dir4 == 1
        
        % Mientras el MS est pulsado los motores 4 y 5 se movern
        % en esa direccin
        while digitalRead(a,pinMS(4))==0
            motor(4,dir4,1);
            motor(5,dir4,1);
        end

        dir4=0; % Se cambia la direccin a 0
        
        % Igual que en los casos anteriores, el motor se mueve en una
        % direccin. Si se llega al maximo antes de pulsar el MS, se 
        % invierte.
        while digitalRead(a,pinMS(4))==1
            enc = encoder(5);
            motor(4,dir4,1);
            motor(5,dir4,1);
            pause(0.01);
            if enc == encoder(5)
                dir4=1;
            end
        end
    end
    motor(4,0,0); %Se para el motor 4
    motor(5,0,0); %Se para el motor 5
    fprintf('.');
    %%
    %Posicionar herramiente (plano horizontal)
        % Mientras no se pulse el MS los motores 4 y 5 se mueven en
        % direccin opuestas. Como no hay limite en el giro no es
        % necesario invertir las direcciones.
        while digitalRead(a,pinMS(5))==1
            motor(4,1,1);
            motor(5,0,1);
            pause(0.01);
        end
        
    motor(4,0,0); % Se para el motor 4
    motor(5,0,0); % Se para el motor 5
    
    %%
    %Abrir la pinza
    pinza('abrir');
    fprintf('.');
    %%
    %Resetear los encoders y poner a 0 los contadores pos4 y pos5
    for i=1:5
        resetEncoder(i)
    end
    fprintf('.');
    
    pos4 = 0;
    pos5 = 0;
    
    %%
    % Se ajusta la posicin de la herramienta en el plano horizontal
    % y se vuelven a poner a 0 los contadores.
    mover(5,-20,1);
    for i=1:5
        resetEncoder(i)
    end
    fprintf('.');
    
    pos4 = 0;
    pos5 = 0;
    %%
    digitalWrite(a,51,0); % Se apaga el LED
     
    % Se imprime un mensaje por pantalla
    fprintf('\nPosicionamiento realizado con exito!\n');
end

